var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import jsonp from 'jsonp';
const handleJsonpFetch = (url, param, name) => {
    return new Promise((res, rej) => {
        jsonp(url, { param, name }, (error, data) => {
            if (error) {
                return rej(error);
            }
            res({ data });
        });
    });
};
// config 留着扩展
// eslint-disable-next-line @typescript-eslint/no-unused-vars
export function createJsonpHandler(config) {
    // eslint-disable-next-line space-before-function-paren
    return function (options) {
        return __awaiter(this, void 0, void 0, function* () {
            const params = typeof options.params === 'object'
                ? JSON.stringify(options.params)
                : options.params;
            const response = yield handleJsonpFetch(options.uri, params || '', options.name);
            return response;
        });
    };
}
